

function [A,at1,ct1] = HouseholdSim(cp,agrid,abar,ainv,zchain,a_init)
amax=max(agrid); 
T   = size(zchain,1);     %number of simulation periods as given in the Markov chain

at(1,1) = a_init;   % Initial value of capital stock 

 if at(1,1)<abar; at(1,1)=abar; elseif at(1,1)>amax; at(1,1)=amax;  end
 
for t = 1:T
    
    
    at(t+1,1) = interp1(ainv((agrid>=abar),zchain(t,1)),agrid(agrid>=abar),at(t,1),'linear','extrap');
    at(t+1,1)=max(at(t+1,1),abar); at(t+1,1)=min(at(t+1,1),amax);
    
   
    ct(t,1) = interp1(agrid(agrid>=abar),cp((agrid>=abar),zchain(t,1)),at(t,1),'linear');
    ct(t,1) = interp1(agrid(agrid>=abar),cp((agrid>=abar),zchain(t,1)),at(t,1),'linear');
    
   % nt(t,1) = find_labor(ct(t,1),zchain(t,1),w,psi,taun);
  
end
at1=at(2001:T); ct1=ct(2001:T)  ;                       
A = mean(at1);      % Compute aggregate wealth 