function [cp,c,ainv,np0]=sub_hh_problem1(cp,ap,taun,r,w,abar,Z,cn)
global   beta  prob Ic eps psi1 psi2 gamma eta B

N=length(ap); 
cp0=max(.001,cp);

ainv=zeros(N,length(Z));
if cn==1
    psi=psi1;
else
    psi=psi2;
end

diff= 1;               % Initial value for the loop's convergence measure
iter=1;
for j=1:length(Z)   
      
     c_con(j)=csolve('Cons_con',.5,[],0.000001,5,B,gamma,eta,psi,taun,w,Z(j),abar,r); c_con(j)=max(eps,c_con(j));
     n_con(j)=((c_con(j)-r*abar)/(taun*(w*Z(j))^psi))^(1/psi); n_con(j)=max(n_con(j),.05); n_con(j)=min(n_con(j),.95);

end

while diff>1e-8 
    iter=iter+1;
    cp=max(eps,cp);
    EMUp = (cp.^(-gamma))*prob';         %Expected marginal utility tomorrow
    EMUp =EMUp(ap>=abar,:); N=length(EMUp); nn=ones(N,1);
    c = (beta*(1+r).*EMUp).^(-1/gamma);       %Consumption today
   
    for j=1:length(Z)
  
    
        for i=1:N
            n0(i,j)=find_labor2(c(i,j),Z(j),w,psi,taun);
            
        end
       a = (c(:,j)+ap(ap>=abar)-sub_ptax2(psi,taun,n0(:,j)*w*Z(j,1)))./(1+r); 
       a = (c(:,j)+ap(ap>=abar)-sub_ptax2(psi,taun,n0(:,j)*w*Z(j,1)))./(1+r); 
       ainv(ap>=abar,j) = a;
       ainv(ap<abar,j)=min(ap(1,1),a(1));
     
   
    
    %If borrowing constraint is binding, then consumption today is c_con,
    %derived from the budget constraint
    if a(1)>=abar
        c_c=linspace(c_con(j),c(1,j),Ic)';
        for i=1:length(c_c)     
                 n_c(i,1)=find_labor2(c_c(i),Z(j),w,psi,taun);
        end
        a_c=(c_c+abar-sub_ptax2(psi,taun,n_c*w*Z(j,1)))./(1+r);
        a = [a_c(1:Ic-1);a]; 
        ctemp=c(:,j); ntemp= n0(:,j);
        ctemp = [c_c(1:Ic-1);ctemp];
    
    else
        ctemp=c(:,j);
     end
  
     cp0(:,j) = interp1(a,ctemp,ap,'linear','extrap');
    
    end
  
     cp0=max(cp0,eps);
     diff = max(max(abs(cp0 - cp)));
     cp=cp0;
end
   
      N=length(cp0); nn=ones(N,1);
    for i=1:N
        for j=1:length(Z)
   
    np0(i,j)=find_labor2(cp0(i,j),Z(j),w,psi,taun); %labor 
        end
    end
    
end                       


