function z = MarkovChain(Prob,T)
rng('default');
z_init=2; %initial state 
rdraw = rand(T,1);

Nz = size(Prob,2);     

z(1,1) = z_init; % The initial state

for t = 1:T

    probnext = Prob(z(t,1),:);
                       %Prob(Z=j|Z=i) for all j
    for j = 1:Nz
        if rdraw(t,1)<= sum(probnext(1:j))        
            z(t+1,1) = j; 
                               break
        end        
    end
end