function [Gamma,bin]=sub_ergodicdist(Gamma,ap,ainv,ag)
global Nstar prob SSprob
%====Finding the ergodic distribution=======================

bin=zeros(length(ag),Nstar);
M=length(ag);
av=[ag(1);((ag(1:M-1)+ag(2:M))/2)']; 
TG = ((SSprob(1,:)'*ones(1,Nstar))./(ones(Nstar,1)*SSprob(1,:)).*prob)';
for j=1:Nstar
    bin(:,j)=interp1(ap,ainv(:,j),av,'linear'); %nearest interp
end
Gamma1 = Gamma;
diff=1; iter=1;
 while diff>1e-6 
for j=1:Nstar
Gamma1(:,j) = interp1(ag,Gamma(:,j),bin(:,j),'linear','extrap');                
Gamma1(:,j)=max(min(Gamma1(:,j),1),0);
end

    Gamma1=TG*Gamma1'; Gamma1=Gamma1';
    Gamma1=[Gamma1(:,1)./Gamma1(M,1) Gamma1(:,2)./Gamma1(M,2) Gamma1(:,3)./Gamma1(M,3)];
    

         
diff = max(max(abs(Gamma1-Gamma)./(1+Gamma)))  ;          
Gamma = Gamma1;                                         
iter=iter+1;
 end

end
 

